<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc00700RecebimentoBandeiraFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getReceiptFlagsPFiltered($params, $query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getReceiptFlagsP($params){
        $sql = "SELECT REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQVENDA)) AS VRVENDA
                  FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C
                  WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                    AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                    AND R.NRCONCLANC = C.NRCONCLANC
                    AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                    AND :P_INTVEND = 'M'
                    AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                    AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                  AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                  AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                  AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                  GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')), B.NMBANDEIRA
                UNION
                  SELECT REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQVENDA)) AS VRVENDA
                    FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C
                  WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                    AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                    AND R.NRCONCLANC = C.NRCONCLANC
                    AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                    AND :P_INTVEND = 'D'
                    AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                    AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                  AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                  AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                  AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                  GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')), B.NMBANDEIRA
                  ORDER BY 2,1,3"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getReceiptFlagsRFiltered($params, $query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getReceiptFlagsR($params){
        $sql = "SELECT REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQPGTO)) AS VRVENDA
                  FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B
                  WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                    AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                    AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                    AND :P_INTVEND = 'M'
                    AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                      AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                  AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                  AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                  AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                  GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')), B.NMBANDEIRA
                UNION
                    SELECT REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQPGTO)) AS VRVENDA
                    FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B
                  WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                    AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                    AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                    AND :P_INTVEND = 'D'
                    AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                      AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                  AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                  AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                  AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                  GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')), B.NMBANDEIRA
                  ORDER BY 2,1,3"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getReceiptFlagsDetailsFiltered($params, $query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getReceiptFlagsDetails($params){
        $sql = "SELECT B.NMBANDEIRA PRIMARY, '' PARENT, NULL DTORDENACAO, B.NMBANDEIRA, NULL DTVENDA, '' CDNSU, 
                    SUM(R.VRBRUTVENDA) VRBRUTO, SUM(R.VRLIQVENDA) VRLIQUIDO, 
                    NULL NRRETVENDAADQ, NULL NRBANDEIRAVAN, NULL NRADQUIRENTE, 
                    '' NMESTABELEC, '' NMADQUIRENTE, NULL NRPRODUTOADQ, '' NMPRODUTOADQ
                      FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C, ESTABELECIMENTO E
                        WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                          AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                          AND R.NRCONCLANC = C.NRCONCLANC
                          AND :MEIORECE = 'P'
                          AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                          AND R.NRESTABELEC = E.NRESTABELEC
                          AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                          AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                          AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                          AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                          AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                      GROUP BY B.NMBANDEIRA
                    UNION
                      SELECT B.NMBANDEIRA || ' - ' || R.NRRETVENDAADQ PRIMARY, B.NMBANDEIRA PARENT,
                      R.DTVENDA DTORDENACAO, '' NMBANDEIRA, TO_CHAR(R.DTVENDA, 'DD/MM/YYYY') DTVENDA, R.CDNSU, R.VRBRUTVENDA VRBRUTO, R.VRLIQVENDA VRLIQUIDO, 
                      R.NRRETVENDAADQ, B.NRBANDEIRAVAN, R.NRADQUIRENTE, E.NMESTABELEC, A.NMADQUIRENTE, R.NRPRODUTOADQ, P.NMPRODUTOADQ
                      FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C, ESTABELECIMENTO E
                        WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                          AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                          AND R.NRCONCLANC = C.NRCONCLANC
                          AND :MEIORECE = 'P'
                          AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                          AND R.NRESTABELEC = E.NRESTABELEC
                          AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                          AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                          AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                          AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                          AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
        UNION ALL
                SELECT B.NMBANDEIRA PRIMARY, '' PARENT, NULL DTORDENACAO, B.NMBANDEIRA, NULL DTVENDA, '' CDNSU, 
                                  SUM(R.VRBRUTVENDA) VRBRUTO, SUM(R.VRLIQPGTO) VRLIQUIDO, 
                                  NULL NRRETFINANCADQ, NULL NRBANDEIRAVAN, NULL NRADQUIRENTE, 
                                  '' NMESTABELEC, '' NMADQUIRENTE, NULL NRPRODUTOADQ, '' NMPRODUTOADQ
                                    FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E
                                      WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                                        AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                                        AND :MEIORECE = 'R'
                                        AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                                        AND R.NRESTABELEC = E.NRESTABELEC
                                        AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                                        AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                                        AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                                        AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                                        AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                                        AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                                    GROUP BY B.NMBANDEIRA
                                  UNION
                                    SELECT B.NMBANDEIRA || ' - ' || R.NRRETFINANCADQ PRIMARY, B.NMBANDEIRA PARENT,
                                    R.DTVENDA DTORDENACAO, '' NMBANDEIRA, TO_CHAR(R.DTVENDA, 'DD/MM/YYYY') DTVENDA, R.CDNSU, R.VRBRUTVENDA VRBRUTO, R.VRLIQPGTO VRLIQUIDO, 
                                    R.NRRETFINANCADQ, B.NRBANDEIRAVAN, R.NRADQUIRENTE, E.NMESTABELEC, A.NMADQUIRENTE, R.NRPRODUTOADQ, P.NMPRODUTOADQ
                                    FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E
                                      WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                                        AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                                        AND :MEIORECE = 'R'
                                        AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                                        AND R.NRESTABELEC = E.NRESTABELEC
                                        AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                                        AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                                        AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                                        AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                                        AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ))
                                        AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN))
                                      ORDER BY DTORDENACAO, PRIMARY"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}
