<?php

namespace Teknisa\CNC\Services;

use Teknisa\CNC\Factories\Cnc01200TaxaParcelaAdquirenteFactory;
use Teknisa\Libs\Util\Environment;

class Cnc01200TaxaParcelaAdquirenteService {
    
    protected $entityManager;
    protected $environment;
    protected $factory;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager,Environment $environment, Cnc01200TaxaParcelaAdquirenteFactory $factory) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->factory = $factory;
    }
    
    public function saveNewTaxa ($row) {
        
        $result = $this->factory->checkQtParcela(array(
            ':NRADQUIRENTE' => $row['NRADQUIRENTE'],
            ':QTPARCELA'    => $row['QTPARCELA']
        ));
        
        if ($row['VRTAXAPARC'] > 100)
            throw new \Exception('MAX_TAXA', 1);
        if ($row['VRTAXAPARC'] <= 0)
            throw new \Exception('INVALID_TAXA', 2);
        if ($row['QTPARCELA'] > 999)
            throw new \Exception('INVALID_PARCELA', 3);
        if ($row['QTPARCELA'] <= 0)
            throw new \Exception('ZERO_PARC', 4);
        if($result[0]['NR'] > 0)
            throw new \Exception('UNIQUE_QTPARCELA', 5);
            
        $this->factory->insertTaxaParcela(array(
            ':NRTAXAADQPARC' => $row['NRTAXAADQPARC'],
            ':NRADQUIRENTE'  => $row['NRADQUIRENTE'],
            ':QTPARCELA'     => $row['QTPARCELA'],
            ':VRTAXAPARC'    => $row['VRTAXAPARC'],
            ':NRORG'         => $row['NRORG'],
            ':IDATIVO'       => $row['IDATIVO'],
            ':DTULTATU'      => $row['DTULTATU'],
            ':NRORGULTATU'   => $row['NRORGULTATU'],
            ':CDOPERULTATU'  => $row['CDOPERULTATU']
        ));
    }
    
    public function validadeEdit ($rows) {
        $validateData = function ($row) {
            
            
            if ($row['VRTAXAPARC'] > 100)
                throw new \Exception('MAX_TAXA', 1);
            if ($row['VRTAXAPARC'] <= 0)
                throw new \Exception('INVALID_TAXA', 2);
            if ($row['QTPARCELA'] > 999)
                throw new \Exception('INVALID_PARCELA', 3);
            if ($row['QTPARCELA'] <= 0)
                throw new \Exception('ZERO_PARC', 4);
            if ($row['fieldChanged']) {
                $result = $this->factory->checkQtParcela(array(
                    ':NRADQUIRENTE'     => $row['NRADQUIRENTE'],
                    ':QTPARCELA'    => $row['QTPARCELA']
                ));
                
                if ($result[0]['NR'] > 0)
                    throw new \Exception('UNIQUE_QTPARCELA', 5);
            }
            
        };
        
        array_walk($rows, $validateData);
    }
}